/*--------------------------------------------------------------------.
| charsel.c							      |
| 								      |
| (c) 1997 Christopher Cave and Jonathan Hudson			      |
| This file is part of the freely distributable menu_rext c68 library |
| It may be distributed under the same terms as c68		      |
| 								      |
| Authors:							      |
|    Christopher Cave    <ccave@cix.compulink.co.uk>		      |
|    Jonathan Hudson     <jrh@jrhudson.demon.co.uk>		      |
`--------------------------------------------------------------------*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <qdos.h>
#include <qptr.h>

#include <things.h>
#include "menu.h"
#include "menuP.h"

int CharSel (char *name, long avbit, char *buf, void *font, int xpos, int ypos, int mainc, int listc)
{
    int iret;
    long vers;
    THING_HEADER_EXT *pThing;
    void *ps = NULL;

    QD_TEXT (39) namestr;
    QD_TEXT (2) rsltstr;

    MENUCHSL cs;

    cs.font = (long) font;
    cs.xpos = xpos;
    cs.ypos = ypos;
    cs.mainc = mainc;
    cs.listc = listc;

    cs.mennm.attr = THP_CALL | THP_OPT | THP_STR;
    cs.mennm.info = 0;
    if (name)
    {
	MOVEIN (namestr, name);
	cs.mennm.ptr = &namestr;
    }
    else
	cs.mennm.ptr = NULL;

    cs.avbit = avbit;
    cs.avbl[0] = cs.avbl[1] = 0;

    cs.retst.attr = THP_RET | THP_PTR | THP_STR | THP_UPD;
    cs.retst.info = 0;
    cs.retst.ptr = &rsltstr;

    if (strlen (buf) < 2)
    {
	MOVEIN (rsltstr, buf);
    }
    else
    {
	rsltstr.len = 0;
    }

    iret = (int) sms_uthg ("Menus", -1, -1, &chsl.x, NULL, &vers, &ps);
    if (iret > 0)
    {
	pThing = (THING_HEADER_EXT *) iret;
	iret = __use_thing (pThing->thh_code, &cs);
	if (iret >= 0)
	{
	    RESTORE (buf, (struct QD_text *) &rsltstr);
	}
	sms_fthg ("Menus", -1, NULL, 0, NULL, NULL);
    }
    return iret;
}
