/*--------------------------------------------------------------------.
| doreport.c							      |
| 								      |
| (c) 1997 Christopher Cave and Jonathan Hudson			      |
| This file is part of the freely distributable menu_rext c68 library |
| It may be distributed under the same terms as c68		      |
| 								      |
| Authors:							      |
|    Christopher Cave    <ccave@cix.compulink.co.uk>		      |
|    Jonathan Hudson     <jrh@jrhudson.demon.co.uk>		      |
`--------------------------------------------------------------------*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <qdos.h>
#include <qptr.h>

#include <things.h>
#include "menu.h"
#include "menuP.h"


int DoReport (char *name, char *desc, int chars, int xpos, int ypos, 
	  int mainc, int mictl, MENU_CB_t func)
{

    void *ps = NULL;
    int iret = -1;
    unsigned long *x;
    long vers;
    int i;
    MENUDORP dp;
    QD_TEXT (39) namestr;
    QD_TEXT (39) descstr;
    AFUNC_t f;
    ACTION_t a;

    if(name)
    {
	MOVEIN (namestr, name);
	dp.mennm.ptr = &namestr;
    }
    else
    {
	dp.mennm.ptr = NULL;
    }

    if(desc)
    {
	MOVEIN (descstr, desc);
	dp.actds.ptr = &descstr;
    }
    else
    {
	dp.actds.ptr = NULL;
    }

    dp.xpos = xpos;
    dp.ypos = ypos;
    dp.mainc = mainc;
    dp.mictl = mictl;
    dp.chars = chars;

    dp.mennm.attr = THP_CALL | THP_OPT | THP_CALL;
    dp.mennm.info = 0;
    dp.actds.attr = THP_CALL | THP_OPT | THP_CALL;
    dp.actds.info = 0;
    a.jsr = JSR;
    a.interface = _menu_act; 
    a.function = &f;
    f.func = func;
    if(chars > 0)
    {
	f.param = alloca(chars+2);
    }
    else
    {
	f.param = NULL;
    }
    dp.pact = &a;
    i = (int) sms_uthg ("Menus", -1, -1, &dorp.x, NULL, &vers, &ps);
    if (i > 0)
    {
	THING_HEADER_EXT *pThing;

	pThing = (THING_HEADER_EXT *) i;
	i = __use_thing (pThing->thh_code, &dp);
	sms_fthg ("Menus", -1, NULL, 0, NULL, NULL);
    }
    return iret;
}
