/*--------------------------------------------------------------------.
| fileselect.c							      |
| 								      |
| (c) 1997 Christopher Cave and Jonathan Hudson			      |
| This file is part of the freely distributable menu_rext c68 library |
| It may be distributed under the same terms as c68		      |
| 								      |
| Authors:							      |
|    Christopher Cave    <ccave@cix.compulink.co.uk>		      |
|    Jonathan Hudson     <jrh@jrhudson.demon.co.uk>		      |
`--------------------------------------------------------------------*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <qdos.h>
#include <qptr.h>

#include <things.h>
#include "menu.h"
#include "menuP.h"

int FileSelect (char *prompt, char *dir, char *ext, char *buf,
		short size, int xpos, int ypos, int mainc, int filec)
{
    int iret;
    long vers;

    void *ps = NULL;
    char *p;
    THING_HEADER_EXT *pThing;

    QD_TEXT (39) menustr;
    QD_TEXT (39) basestr;
    QD_TEXT (39) dirstr;
    QD_TEXT (39) rsltstr;
    QD_TEXT (39) extstr;

    MENUFSEL s;

    s.mennm.attr = THP_CALL | THP_OPT | THP_STR;
    s.mennm.info = 0;
    s.mennm.ptr = &menustr;

    s.defnm.attr = THP_CALL | THP_OPT | THP_STR;
    s.defnm.info = 0;
    s.defnm.ptr = &basestr;

    s.dirnm.info = 0;
    if((long)dir > 0)
    {
	s.dirnm.attr = THP_OPT | THP_STR | THP_UPD | THP_SLNG;
	s.dirnm.ptr = &dirstr;
	MOVEIN (dirstr, dir);
    }
    else 
    {
	s.dirnm.attr = THP_CALL|THP_OPT|THP_STR|THP_UPD;
	s.dirnm.ptr = dir;
    }
    s.extnm.attr = THP_OPT | THP_STR | THP_UPD;
    s.extnm.info = 0;
    s.extnm.ptr = &extstr;

    s.fname.attr = THP_RET | THP_STR;
    s.fname.info = 0;
    s.fname.ptr = &rsltstr;

    MOVEIN (menustr, prompt);
    MOVEIN (basestr, buf);
    MOVEIN (extstr, ext);

    s.size = size;
    s.xpos = xpos;
    s.ypos = ypos;
    s.mainc = mainc;
    s.filec = filec;

    rsltstr.len = 0;

    iret = (int) sms_uthg ("Menus", -1, -1, &fsel.x, NULL, &vers, &ps);
    if (iret > 0)
    {
	pThing = (THING_HEADER_EXT *) iret;
	iret = __use_thing (pThing->thh_code, &s);
	if (iret >= 0)
	{
	    RESTORE (buf, (struct QD_text *) &rsltstr);
	    if((long)dir > 0)
	    {
		RESTORE (dir, (struct QD_text *) &dirstr);
	    }
	    RESTORE (ext, (struct QD_text *) &extstr);
	}
	sms_fthg ("Menus", -1, NULL, 0, NULL, NULL);
    }
    return iret;
}
