/*--------------------------------------------------------------------.
| demo.c							      |
| 								      |
| (c) 1997 Christopher Cave and Jonathan Hudson			      |
| This file is part of the freely distributable menu_rext c68 library |
| It may be distributed under the same terms as c68		      |
| 								      |
| Authors:							      |
|    Christopher Cave    <ccave@cix.compulink.co.uk>		      |
|    Jonathan Hudson     <jrh@jrhudson.demon.co.uk>		      |
`--------------------------------------------------------------------*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <qdos.h>
#include <qptr.h>

#include <things.h>
#include <menu.h>

char _prog_name[] = "Menu Thing C-demo";

long _stack = 8000;		/* MENU_REXT likes _lots_ of stack */
static int con;

int printf (const char *ctl,...)
{
    va_list va;
    char t[80];
    va_start (va, ctl);
    vsprintf (t, ctl, va);
    va_end (va);
    io_sstrg (con, -1, t, (short) strlen (t));
}

static long doact(int chan, int flag, short maxres, QD_text_t *res)
{
    short i,col;
    QLRECT_t r;
    r.q_height = 10;
    r.q_x = r.q_y = 0;
    sd_clear(chan, 0);
    for(i = 0; i < maxres; )
    { 
	i++;
	r.q_width = i*6;
	sd_fill(chan, 5, 2, &r);
	mt_susjb(-1, 10, NULL);
    }
    if(res)
    {
	strcpy((char *)res->chrs, "Only joking (this time)");
	res->len = strlen ((char *)res->chrs);
    }
    return 0;
}

int main (void)
{

/*==================== Menu Extension ====================*/

    static short condef[] = {480,200,16,28};
    char ci[2];


    MENU_INIT;

    Button ("Cdemo", -1, -1, -1);
             
    con = io_open("con", 0);
    iop_outl(con, -1, 0, 0, 0, condef);
    sd_wdef(con, -1, 2, 1, (struct QLRECT *) condef);
    sd_clear(con, -1);                             

    beep (20000, 30);

    printf ("\nDead easy to set up a C-prog with no open window!!\n");
    printf ("\nPress <ENTER> to continue");
    io_fbyte(con, -1, ci);

    {
	char dir[72] = "win1_";
	char buf[72] = "win2__";
	char ext[36] = "_c";
	/* p & buf must be big enough for long file names */

	int iret;

	iret = FileSelect ("Menu File Select Test", (char *)-2, ext, buf, 0, 0, 0, 2, 2);
	printf ("FSEL:<%d> dir=<%s>\nFSEL:buf=<%s> (%s)\n", 
		iret, dir, buf, ext);
	strcpy(buf,"win1__"); 
	iret = FileSelect ("Menu File Select Test", dir, ext, buf, 0, 0, 0, 2, 2);

	printf ("FSEL:<%d> dir=<%s>\nFSEL:buf=<%s> (%s)\n", 
		iret, dir, buf, ext);

	if (iret >= 0)
	{
	    ViewFile (buf, NULL, NULL, 0, -1, -1);
	    printf ("VIEW:\n");
	}
    }


    {
	int iret;
	char buf[40] = "";

	iret = DirSelect ("Directory Select", buf, 0, 0, 0, -1, -1);
	printf ("DSEL:<%d>%s\n", iret, buf);
    }

    {
	char buf[8] = "";
	int iret;

	iret = ExtSelect (buf, 0, 0, -1);
	printf ("XSEL:<%d>%s\n", iret, buf);
    }

    {
	printf ("ITSL:<%d>\n", ItemSelect ("ItemSelect", "Prompt Text\non two lines.",
				      "Item2", "Item1", "Item3", 0, 0, -1));
	printf ("ITSL:<%d>\n", ItemSelect ("ItemSelect", "Prompt Text on one line",
					   "Item1", NULL, NULL, 0, 0, -1));
	printf ("ITSL:<%d>\n", ItemSelect ("No Prompt Text", NULL, "Item1", "Item2", NULL,
					   -1, -1, -1));
    }

    {
	ReportError (-2, 0, 0, -1);
	/* No action taken when error>=0 */
	ReportError (1, 0, 0, -1);
    }

    {
	int d0;

	d0 = FileError (-1, 0, -1, -1, -1);
	printf ("FERR: -1 => %d\n", d0);
	d0 = FileError (-2, 1, -1, -1, -1);
	printf ("FERR: -2 => %d\n", d0);
	printf ("FERR: -4 => %d\n", FileError (-4, 0, -1, -1, -1));
	printf ("FERR: -7 => %d\n", FileError (-7, 1, -1, -1, -1));
	printf ("FERR:-13 => %d\n", FileError (-13, 1, -1, -1, -1));
	printf ("FERR:-15 => %d\n", FileError (-15, 0, -1, -1, -1));
	printf ("FERR:-16 => %d\n", FileError (-16, 1, -1, -1, -1));
	printf ("FERR:-20 => %d\n", FileError (-20, 0, -1, -1, -1));
	printf ("FERR:-22 => %d\n", FileError (-22, 1, -1, -1, -1));
	printf ("FERR:*-3 => %d\n", FileError (-22, 1, -1, -1, -1));
    }

    {
	char buf[40];
	int iret;

	*buf = 0;
	iret = ReadString ("Title", "Prompt", "Initial string", 0x10000, buf, 0, 0, -1);
	printf ("RSTR:%s\n", buf);
    }

    {
	int nitems, i;
	static char *items[] =
	{
	    {"Christopher Cave"},
	    {"Jonathan Hudson"},
	    {"Jochen Merz"},
	    {"Dave Walker"},
	    {"Tony Tebby"},
	    {"Mickey Mouse"}
	};
	static short sts[sizeof (items) / sizeof (char *)]= {WSI_AVBL};
	nitems = sizeof (items) / sizeof (char *);
	i = ListSelect ("List Select", items, nitems,
			1, 0, 0, 0, 0, -1, -1, sts);
	printf ("LIST:<%d>\n", i);
	if(i >= 0)
	{
	    *(sts+i) = WSI_UNAV;
	}
	i = ListSelect ("List Select", items, nitems, 
			1 + 16, 0, 0, 0, 0, -1, -1, sts);
	if(i >= 0)
	{
	    *(sts+i) = WSI_UNAV;
	}

	printf ("LIST:<%d>\n", i);
	i = ListSelect ("List Select", items, nitems, 
			4, 0, 0, 0, 0, -1, -1, sts);
	if(i >= 0)
	{
	    *(sts+i) = WSI_UNAV;
	}
	printf ("LIST:<%d>\n", i);
	i = ListSelect ("List Select", items, nitems, 
			4 + 16, 0, 0, 0, 0, -1, -1, sts);
	printf ("LIST:<%d>\n", i);
	{
	    static char *xx[2] = {"Been there","Done that"};
	    i = ListSelect ("List Select", xx, 2, 
			0, 0, 0, 0, 0, -1, -1, NULL);
	    printf ("LIST:<%d>\n", i);
	}
    }

    {
	char buf[2];
	int i;

	*(buf+0) = '?';
	*(buf+1) = 0;

	i = CharSel ("CHSL Test", 0x0000003f, buf, NULL, -1, -1, 2, 2);
	printf ("CHSL:<%d><%c>\n", i, *buf);
    }

    {
	char buf[40];

	printf ("INFO:%s\n", MenuInfo (32, buf));
    }

/*==================== Scrap Extension ====================*/

    {
	QD_TEXTI (text, "Scrap Extension");
	PutScrap (0, &text, 0, NULL);
    }

    {
	unsigned char datatype = 0x99;
	unsigned short modifycount = 0x8888;
	unsigned long buflen = 0xeeeeeeee;

	printf ("SCRAPINFO:<%d>", GetScrapInfo ((unsigned char *) &datatype,
					    (unsigned short *) &modifycount,
						(unsigned long *) &buflen));
	printf ("<%d><%d><%d>\n", (char) datatype, modifycount, buflen);

	if (0 == datatype && buflen)
	{
	    QD_text_t *dataptr;
	    int iret;

	    dataptr = (QD_text_t *) malloc (2 + buflen);
	    if (dataptr)
	    {
		if (0 > (iret = GetScrap (0, dataptr, 2 + buflen, NULL)))
		    ReportError (iret, 0, 0, -1);;
		printf ("SCRAPGET:<%d>%d-<%.*s>\n", iret, dataptr->len,
			dataptr->len, (char *) dataptr->chrs);
		free (dataptr);
	    }
	}
    }

    ClearScrap ();

    DoReport ("Non--abortable Action", 
	      "Formatting your hard disk ...", 40, -1, -1, 0, 4, doact);

    printf("Hit a key");
    io_fbyte(con, -1, ci);
    return 0;
}
int (*_Cstart) () = main;
