#ifndef MENUP_H
#define MENUP_H

/*--------------------------------------------------------------------.
| menuP.h							      |
| 								      |
| (c) 1997 Christopher Cave and Jonathan Hudson			      |
| This file is part of the freely distributable menu_rext c68 library |
| It may be distributed under the same terms as c68		      |
| 								      |
| Authors:							      |
|    Christopher Cave    <ccave@cix.compulink.co.uk>		      |
|    Jonathan Hudson     <jrh@jrhudson.demon.co.uk>		      |
`--------------------------------------------------------------------*/


typedef struct
{
   unsigned short attr;
   short info;
   void *ptr;
} MENUP;

typedef struct
{
   unsigned short attr;
   short info;
   unsigned long *x;
} MENUL;

typedef struct
{
   MENUP   mennm;
   MENUP   defnm;
   MENUP   dirnm;
   MENUP   extnm;
   long    size;
   long    xpos;
   long    ypos;
   long    mainc;
   long    filec;
   MENUP   fname;
} MENUFSEL;

typedef struct
{
   MENUP   mennm;
   long    lines;
   long    xpos;
   long    ypos;
   long    mainc;
   long    ddirc;
   MENUP   fname;
} MENUDSEL;

typedef struct
{
   long    xpos;
   long    ypos;
   long    mainc;
   MENUP   fname;
} MENUXSEL;

typedef struct
{
   MENUP mennm;
   MENUP prmpt;
   MENUP item1;
   MENUP item2;
   MENUP item3;
   long xpos;
   long ypos;
   long mainc;
   MENUP retn;
} MENUITSL;

typedef struct
{
   long error;
   long xpos;
   long ypos;
   long mainc;
} MENURPER;

typedef struct
{
   long error;
   long optns;
   long xpos;
   long ypos;
   long mainc;
   MENUP actn;
} MENUFERR;

typedef struct
{
   MENUP mennm;
   MENUP defnm;
   MENUP prmpt;
   long chars;
   long xpos;
   long ypos;
   long mainc;
   MENUP fname;
} MENURSTR;

typedef struct
{
   MENUP filnm;
   MENUP start;
   MENUP end;
   long chars;
   long mainc;
   long listc;
} MENUVIEW;

typedef struct
{
   MENUP name;
   long xpos;
   long ypos;
   long mainc;
} MENUBUTN;

typedef struct
{
   MENUP name;
   long xpos;
   long ypos;
   long mainc;
   long spr2;
   long opts;
   MENUP retk;
} MENUXBTN;

typedef struct
{
   MENUP mennm;
   MENUP itlst;
   MENUP stlst;
   long mictl;
   long lines;
   long colms;
   long xpos;
   long ypos;
   long mainc;
   long listc;
   MENUP retn;
} MENULIST;

typedef struct
{
   MENUP mennm;
   long avbit;
   long avbl[2];
   long font;
   long xpos;
   long ypos;
   long mainc;
   long listc;
   MENUP retst;
} MENUCHSL;

typedef struct
{
    MENUP mennm;
    MENUP actds;
    long  chars;
    long xpos;
    long ypos;
    long mainc;
    long mictl;
    void *pact;
} MENUDORP;

typedef struct
{
   long key;
   MENUP result;
} MENUINFO;

typedef struct
{
   MENUP dtyp;
   MENUP mcnt;
   MENUP bufl;
} SCRAPINFO;

typedef struct
{
   short opt;
   unsigned char pack;
   unsigned char dtyp;
   MENUP strg;
   long flln;
   void *uccd;
} SCRAPPUT;

typedef struct
{
   short opt;
   unsigned char pack;
   unsigned char dtyp;
   void *dest;
   unsigned long bufl;
   void *uccd;
} SCRAPGET;

typedef union 
{
    char txt[4];
    long x;
} ALIGN;

#define THP_UPD     0xe100
#define THP_CALL    0xc000
#define THP_RET     0xa000
#define THP_PTR     0x8000
#define THP_OPT     0x1000
#define THP_NNUL    0x0800
#define THP_ARR     0x0800
#define THP_CHAR    0x0004
#define THP_UBYT    0x0008
#define THP_SBYT    0x000a
#define THP_UWRD    0x0010
#define THP_SWRD    0x0012
#define THP_ULNG    0x0020
#define THP_SLNG    0x0022
#define THP_FP8     0x0042
#define THP_STR     0x0100
#define THP_SSTR    0x0200

static const ALIGN dsel = {"DSEL"};
static const ALIGN fsel = {"FSEL"};
static const ALIGN xsel = {"XSEL"};
static const ALIGN itsl = {"ITSL"};
static const ALIGN rper = {"RPER"};
static const ALIGN ferr = {"FERR"};
static const ALIGN rstr = {"RSTR"};
static const ALIGN list = {"LIST"};
static const ALIGN view = {"VIEW"};
static const ALIGN butn = {"BUTN"};
static const ALIGN dorp = {"DORP"};
static const ALIGN chsl = {"CHSL"};
static const ALIGN info = {"INFO"};
static const ALIGN xbtn = {"XBTN"};

static const ALIGN clr={"CLR "};
static const ALIGN put={"PUT "};
static const ALIGN get={"GET "};

typedef struct
{
   void *ptr;
   short ndims;
   short nitems0;
   short mult0;
   short nitems1;
   short mult1;
} ARRAYDESC;

typedef struct 
{
    MENU_CB_t func;
    void *param;
} AFUNC_t;

typedef struct 
{
    SCRAP_CB_t func;
    void *param;
} SFUNC_t;

typedef struct
{
    short jsr;
    long (*interface)(void);
    void *function;
} ACTION_t;

#ifndef JSR
# define JSR 0x4EB9
#endif

extern int __use_thing (void *, void *);
extern long _menu_act (void);
extern long _scrap_act(void);

#define RESTORE(p, q)  strncpy((p), (char*)(q)->chrs, (q)->len); \
     *((p) + (q)->len) = '\0';
#define MOVEIN(s, t) s.len = strlen(t); strcpy((char *)s.chrs, t)
#define MOVEINP(s, t) s->len = strlen(t); strcpy((char *)s->chrs, t)

#endif
