/*--------------------------------------------------------------------.
| readstring.c							      |
| 								      |
| (c) 1997 Christopher Cave and Jonathan Hudson			      |
| This file is part of the freely distributable menu_rext c68 library |
| It may be distributed under the same terms as c68		      |
| 								      |
| Authors:							      |
|    Christopher Cave    <ccave@cix.compulink.co.uk>		      |
|    Jonathan Hudson     <jrh@jrhudson.demon.co.uk>		      |
`--------------------------------------------------------------------*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <qdos.h>
#include <qptr.h>

#include <things.h>
#include "menu.h"
#include "menuP.h"

int ReadString (char *name, char *prmpt, char *dflt, int chars, char *buf,
		int xpos, int ypos, int mainc)
{
    int iret;
    long vers;
    THING_HEADER_EXT *pThing;
    void *ps = NULL;

    QD_TEXT (39) namestr;
    QD_TEXT (39) dfltstr;
    QD_TEXT (39) prmptstr;
    QD_TEXT (39) rsltstr;

    MENURSTR rs;

    rs.chars = chars;
    rs.xpos = xpos;
    rs.ypos = ypos;
    rs.mainc = mainc;

    rs.mennm.attr = THP_CALL | THP_STR;
    rs.mennm.info = 0;
    if (name)
    {
	MOVEIN (namestr, name);
	rs.mennm.ptr = &namestr;
    }
    else
	rs.mennm.ptr = NULL;

    rs.defnm.attr = THP_CALL | THP_STR;
    rs.defnm.info = 0;
    if (dflt)
    {
	MOVEIN (dfltstr, dflt);
	rs.defnm.ptr = &dfltstr;
    }
    else
	rs.defnm.ptr = NULL;

    rs.prmpt.attr = THP_CALL | THP_STR;
    rs.prmpt.info = 0;
    if (prmpt)
    {
	MOVEIN (prmptstr, prmpt);
	rs.prmpt.ptr = &prmptstr;
    }
    else
	rs.prmpt.ptr = NULL;

    rs.fname.attr = THP_RET | THP_STR;
    rs.fname.info = 0;
    rs.fname.ptr = &rsltstr;
    rsltstr.len = 0;

    iret = (int) sms_uthg ("Menus", -1, -1, &rstr.x, NULL, &vers, &ps);
    if (iret > 0)
    {
	pThing = (THING_HEADER_EXT *) iret;
	iret = __use_thing (pThing->thh_code, &rs);
	if (iret >= 0)
	{
	    RESTORE (buf, (struct QD_text *) &rsltstr);
	}
	sms_fthg ("Menus", -1, NULL, 0, NULL, NULL);
    }
    return iret;
}
