/*--------------------------------------------------------------------.
| demo.c							      |
| 								      |
| (c) 1997 Christopher Cave and Jonathan Hudson			      |
| This file is part of the freely distributable menu_rext c68 library |
| It may be distributed under the same terms as c68		      |
| 								      |
| Authors:							      |
|    Christopher Cave    <ccave@cix.compulink.co.uk>		      |
|    Jonathan Hudson     <jrh@jrhudson.demon.co.uk>		      |
`--------------------------------------------------------------------*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <qdos.h>
#include <qptr.h>

#include <things.h>
#include <menu.h>

char _prog_name[] = "Menu Thing C-demo";

long _stack = 8000;		/* MENU_REXT likes _lots_ of stack */

long func(STHG *q, SUDATA *p)
{
    long rv;
    printf("Buffer is %x %d %d %d %d (%x), %d\n", 
	   q, q->type, q->count, q->maxsize, q->cursize, p->ptr, p->len);
    if(q->type == 0 && q->cursize < p->len)
    {
	memcpy(p->ptr, q->data, q->cursize);
	rv = 0;
    }
    else
    {
	rv = -5;
    }
    return rv;
}

int main (void)
{
    MENU_INIT;

    {
	static QD_TEXTI(text, "Scrap Extension");
	PutScrap (0, &text, 0, NULL);
    }

    {
	QD_text_t *dataptr;
	int iret;
	int buflen = 40;

	dataptr = (QD_text_t *) malloc (2 + buflen);
	if (dataptr)
	{
	    iret = GetScrap (0, (void *) dataptr, 2 + buflen, func);
	    printf ("SCRAPGET:<%x>%d-<%.*s>\n", iret, 
		    dataptr->len,dataptr->len,
		    (char *) dataptr->chrs);
	    free (dataptr);
	}
    }

    return 0;
}
