/*--------------------------------------------------------------------.
| viewfile.c							      |
| 								      |
| (c) 1997 Christopher Cave and Jonathan Hudson			      |
| This file is part of the freely distributable menu_rext c68 library |
| It may be distributed under the same terms as c68		      |
| 								      |
| Authors:							      |
|    Christopher Cave    <ccave@cix.compulink.co.uk>		      |
|    Jonathan Hudson     <jrh@jrhudson.demon.co.uk>		      |
`--------------------------------------------------------------------*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <qdos.h>
#include <qptr.h>

#include <things.h>
#include "menu.h"
#include "menuP.h"

void ViewFile (char *fname, char *start, char *end, short nchars, int mainc, int listc)
{
    int iret;
    long vers;
    THING_HEADER_EXT *pThing;
    void *ps = NULL;
    QD_TEXT (39) namestr;
    QD_TEXT (39) startstr;
    QD_TEXT (39) endstr;
    MENUVIEW v;

    if (fname)
    {
	v.filnm.attr = THP_CALL | THP_STR;
	v.filnm.info = 0;
	v.filnm.ptr = &namestr;
	MOVEIN (namestr, fname);
    }
    else
    {
	return;
    }

    v.start.attr = THP_CALL | THP_STR;
    v.start.info = 0;
    if (start)
    {
	MOVEIN (startstr, start);
	v.start.ptr = &startstr;
    }
    else
	v.start.ptr = NULL;

    v.end.attr = THP_CALL | THP_STR;
    v.end.info = 0;
    if (end)
    {
	MOVEIN (endstr, end);
	v.end.ptr = &endstr;
    }
    else
	v.end.ptr = NULL;

    v.chars = nchars;
    v.mainc = mainc;
    v.listc = listc;

    iret = (int) sms_uthg ("Menus", -1, -1, &view.x, NULL, &vers, &ps);
    if (iret > 0)
    {
	pThing = (THING_HEADER_EXT *) iret;
	__use_thing (pThing->thh_code, &v);
	sms_fthg ("Menus", -1, NULL, 0, NULL, NULL);
    }
}
